﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Collections;

namespace CreateBitmap {

    public class CMiddleware {

        public CMiddleware()    {

        }

        // Fields 

        public CBitmap bitmap = new CBitmap();
        private string filename = "bild.bmp";

        private List<byte> pixelliste = new List<byte>();

        // Methods 
        public List<CRGB_Quad> getQuadliste()
        {
            return bitmap.quadliste;
        }
        public CRGB_Quad getQuad(int i)
        {
            return bitmap.quadliste[i];
        }
        public void addColor(CRGB_Quad color)
        {
            this.bitmap.quadliste.Add(color);
        }

        // Pixel
        public void addPixel(byte pixel)   {
            pixelliste.Add(pixel);
        }

        public void clearBits()  {
            this.pixelliste.Clear();            
        }
        public void clearColor()  {
            this.bitmap.quadliste.Clear();            
        }
        public void save2File()  {
            if (this.filename.Equals("")) {
                Basis.ErrorMsg("Bitmap speichern", "Der Dateiname ist leer");
            }
            else {
                this.bitmap.save2File(this.filename);
            }
        }

        // Properties 
        public ushort Colordepth    {
            get   { return this.bitmap.Colordepth; }
            set { this.bitmap.Colordepth = value; }
        }
        public ushort NumberofColors {
            get {
                switch (bitmap.Colordepth) {
                    case 1: return 2;
                    case 4: return 16;
                    case 8: return 256;
                    default: return 0;
                }
            }
        }

        public List<byte> listeBits {
            get { return this.pixelliste; }
        }

        // 1:  8x 1 Bit
        // 4:  2x 4 Bit
        // 8:  1x 8 Bit
        // mache aus der pixelliste eine Bitfolge
        public void createBitmapByteliste()   {
            uint numberofpixel = bitmap.Pixelwidth * bitmap.Colordepth;  // 40
            uint anzahlBytesProZeile = (numberofpixel) >> 3;   // 5 Bytes
            if (numberofpixel % 8 > 0) {
                anzahlBytesProZeile++;  // Rundung, der letzte Rest
            }
            // check ob Vielfaches
            uint restBytes = 0;
            uint rest = anzahlBytesProZeile % 4;
            if (rest > 0) {
                restBytes = 4 - rest;
            }



            byte pixelnumber = 0;
            bitmap.byteliste.Clear();
            int index = 0;
            int bytepixel = 0;
            // pixelwidth       10 pixel  ==>  1 Byte 2 Bits    aber 4 Byte gesamt
            int anzPixelProZeile = 0;
            int anzBytesProZeile = 0;
            switch (bitmap.Colordepth) {
                case 1:
                    pixelnumber = 8;
                    index = 0;
                    bytepixel = 0;
                    foreach (byte pixel in pixelliste) {
                        index++;
                        bytepixel |= pixel << (pixelnumber - index);
                        anzPixelProZeile++;
                        if (index == pixelnumber) {
                            // speichern
                            bitmap.byteliste.Add((byte)bytepixel);
                            anzBytesProZeile++;
                            index = 0;
                            bytepixel = 0;
                        }
                        // Check auf Zeilenende?
                        if (anzPixelProZeile == bitmap.Pixelwidth) {
                            if (index >0) {
                                // wenn pixelwidth = 41 oder 15 ist
                                bitmap.byteliste.Add((byte)bytepixel);
                                anzBytesProZeile++;
                            }
                            byte b = 0;
                            for (int i = 0; i < restBytes; i++) {
                                bitmap.byteliste.Add(b);
                            }

                            anzPixelProZeile = 0; // neue zeile
                            anzBytesProZeile = 0;
                            index = 0;
                            bytepixel = 0;
                        }
                    }
                    break;

                case 4: 
                    pixelnumber = 2;
                    index = 0;
                    bytepixel = 0;
                    foreach (byte pixel in pixelliste) {
                        index++;
                        if (index==1) {
                            bytepixel |= pixel << 4;
                        }
                        else {
                            // speichern
                            bytepixel |= pixel;
                            bitmap.byteliste.Add((byte)bytepixel);
                            anzBytesProZeile++;
                            index = 0;
                            bytepixel = 0;
                        }
                        anzPixelProZeile++;
                        // Check auf Zeilenende?
                        if (anzPixelProZeile == bitmap.Pixelwidth) {
                            if (index == 1) {
                                // wenn pixelwidth = 11 oder 15 ist
                                bitmap.byteliste.Add((byte)bytepixel);
                                anzBytesProZeile++;
                            }
                            byte b = 0;
                            for (int i = 0; i < restBytes; i++) {
                                bitmap.byteliste.Add(b);
                            }
                            anzPixelProZeile = 0; // neue zeile
                            anzBytesProZeile = 0;
                            index = 0;
                            bytepixel = 0;
                        }
                    }
                    break;

                case 8:
                    anzPixelProZeile = 0;
                    foreach (byte pixel in pixelliste) {  // eigentliche Farbwerte als Indexwert
                        anzPixelProZeile++;
                        bitmap.byteliste.Add(pixel);
                        if (anzPixelProZeile == bitmap.Pixelwidth) {
                            byte b = 0;
                            for (int i = 0; i < restBytes; i++) {
                                bitmap.byteliste.Add(b);
                            }
                            anzPixelProZeile = 0;
                        }
                    }  // for  (int pixel : bitmap.pixelliste) {
                    break;
                default: return;
            }
        }  // createlisteBits


        public List<CRGB_Quad> listeColor {
            get { return this.bitmap.quadliste; }
        }


        public uint Pixelheight {
            get { return this.bitmap.Pixelheight;  }
            set { this.bitmap.Pixelheight = value;  }
        }

        public uint Pixelwidth {
            get { return this.bitmap.Pixelwidth; }
            set { this.bitmap.Pixelwidth = value; }
        }

        public string Filename {
            get { return this.filename; }
            set {
                if (!value.Equals("")) {
                    this.filename = value;
                }
            }
        } 

    }
}
