﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CreateBitmap {
    /// <summary>
    /// Interaction logic for ColorDialog.xaml
    /// </summary>
    public partial class FColorDialog : Window {

        private String dbtable = "FColorDialog";

        private byte red = 0;
        private byte green = 0;
        private byte blue = 0;
        private bool bRetCode = false;

        private bool bRedChange = false;
        private bool bGreenChange = false;
        private bool bBlueChange = false;

        bool bStart = true;

        public bool Retcode {
            get { return bRetCode; }
        }

        public byte Red {
            get { return red; }
        }
        public byte Green {
            get { return green; }
        }
        public byte Blue {
            get { return blue; }
        }


        public FColorDialog(Window owner)
        {
            InitializeComponent();

            //Basis.setWindowPositionFromRegistryWidthHeight(this, Registry.C_REG_ADR_IGM + "\\position", "dialog" + dbtable);
            this.Owner = owner;  // Important, because CenterOwner           
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;

            sliderRed.Value = 0;
            sliderGreen.Value = 0;
            sliderBlue.Value = 0;
            bStart = false;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            bStart = false;
            setFontsize();
        }
        private void setFontsize()    {
            //int fHeadersize = IGMRegistry.HeaderFont;
            //int fNormalsize = IGMRegistry.NormalFont;
            //this.FontSize = fNormalsize;
            //labelTitel.FontSize = fHeadersize;
        }


        public void setColor(int red, int green, int blue)    {
            sliderRed.Value = red;
            sliderGreen.Value = green;
            sliderBlue.Value = blue;
        }

        private void drawColor()    {

            // showColor.Background = new SolidColorBrush( Color.FromRgb(red, green, blue) );
            showColor.Background = new SolidColorBrush(Color.FromArgb(255, (byte)red, (byte)green, (byte)blue));
        }

        private void sliderRed_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)      {
            if (bStart) return;
            if (bRedChange) return;
            red = (byte)Math.Round(sliderRed.Value);
            bRedChange = true;
            tInputRed.Text = red.ToString();
            bRedChange = false;
            drawColor();
        }
        private void tInputRed_TextChanged(object sender, TextChangedEventArgs e)    {
            if (bStart) return;
            if (bRedChange) return;
            string sColor = tInputRed.Text;
            int ivalue;
            bool bcanConvert = int.TryParse(sColor, out ivalue);
            if (bcanConvert) {
                red = (byte)ivalue;
                bRedChange = true;
                sliderRed.Value = ivalue;
                bRedChange = false;
                drawColor();
            }
        }

        private void sliderGreen_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)     {
            if (bStart) return;
            if (bGreenChange) return;
            green = (byte)Math.Round(sliderGreen.Value);
            bGreenChange = true;
            tInputGreen.Text = green.ToString();
            bGreenChange = false;
            drawColor();
        }
        private void tInputGreen_TextChanged(object sender, TextChangedEventArgs e)     {
            if (bStart) return;
            if (bGreenChange) return;
            string sColor = tInputGreen.Text;
            int ivalue;
            bool bcanConvert = int.TryParse(sColor, out ivalue);
            if (bcanConvert) {
                green = (byte)ivalue;
                bGreenChange = true;
                sliderGreen.Value = ivalue;
                bGreenChange = false;
                drawColor();
            }
        }

        private void sliderBlue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)     {
            if (bStart) return;
            if (bBlueChange) return;
            blue = (byte)Math.Round(sliderBlue.Value);
            bBlueChange = true;
            tInputBlue.Text = blue.ToString();
            bBlueChange = false;
            drawColor();
        }
        private void tInputBlue_TextChanged(object sender, TextChangedEventArgs e)     {
            if (bStart) return;
            if (bBlueChange) return;
            string sColor = tInputBlue.Text;
            int ivalue;
            bool bcanConvert = int.TryParse(sColor, out ivalue);
            if (bcanConvert) {
                blue = (byte)ivalue;
                bBlueChange = true;
                sliderBlue.Value = ivalue;
                bBlueChange = false;
                drawColor();
            }
        }


        private void Window_KeyDown(object sender, KeyEventArgs e)     {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Cancel)) {
                e.Handled = true;
                bnCancel_Click(sender, e);
            }
        }


        private void bnOk_Click(object sender, RoutedEventArgs e)      {
            bRetCode = true;
            Close();
        }

        private void bnCancel_Click(object sender, RoutedEventArgs e)      {
            Close();
        }

        private void UniformGrid_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)    {
            Color color = Colors.White;
            bool bOkay = false;
            if (e.Source == bnWhite) {
                color = Colors.White;
                bOkay = true;
            }
            if (e.Source == bnBlack) {
                color = Colors.Black;
                bOkay = true;
            }

            if (e.Source == bnRed) {
                color = Colors.Red;
                bOkay = true;
            }
            if (e.Source == bnBlue) {
                color = Colors.Blue;
                bOkay = true;
            }
            if (e.Source == bnGreen) {
                color = Colors.Green;
                bOkay = true;
            }
            if (e.Source == bnYellow) {
                color = Colors.Yellow;
                bOkay = true;
            }
            if (e.Source == bnAqua) {
                color = Colors.Aqua;
                bOkay = true;
            }
            if (e.Source == bnNavy) {
                color = Colors.Navy;
                bOkay = true;
            }
            if (e.Source == bnSilver) {
                color = Colors.Silver;
                bOkay = true;
            }
            if (e.Source == bnPink) {
                color = Colors.Pink;
                bOkay = true;
            }
            if (e.Source == bnViolet) {
                color = Colors.Violet;
                bOkay = true;
            }
            if (e.Source == bnOrange) {
                color = Colors.Orange;
                bOkay = true;
            }
            if (e.Source == bnGold) {
                color = Colors.Gold;
                bOkay = true;
            }
            if (e.Source == bnLightGray) {
                color = Colors.LightGray;
                bOkay = true;
            }
            if (e.Source == bnDarkGray) {
                color = Colors.DarkGray;
                bOkay = true;
            }
            if (e.Source == bnLightCyan) {
                color = Colors.LightCyan;
                bOkay = true;
            }
            if (e.Source == bnOlive) {
                color = Colors.Olive;
                bOkay = true;
            }



            if (e.Source == bnDarkViolet) {
                color = Colors.DarkViolet;
                bOkay = true;
            }


            if (e.Source == bnDeepPink) {
                color = Colors.DeepPink;
                bOkay = true;
            }


            if (e.Source == bnOrangeRed) {
                color = Colors.OrangeRed;
                bOkay = true;
            }


            if (e.Source == bnDarkBlue) {
                color = Colors.DarkBlue;
                bOkay = true;
            }


            if (e.Source == bnBrown) {
                color = Colors.Brown;
                bOkay = true;
            }


            if (e.Source == bnMagenta) {
                color = Colors.Magenta;
                bOkay = true;
            }


            if (e.Source == bnTeal) {
                color = Colors.Teal;
                bOkay = true;
            }


            if (e.Source == bnIndigo) {
                color = Colors.Indigo;
                bOkay = true;
            }


            if (e.Source == bnKhaki) {
                color = Colors.Khaki;
                bOkay = true;
            }

            if (e.Source == bnTransparent) {
                color = Colors.Transparent;
                bOkay = true;
            }



            if (bOkay) {
                sliderRed.Value = color.R;
                sliderGreen.Value = color.G;
                sliderBlue.Value = color.B;
            }
            else {
                MessageBox.Show("Fehlerhafte Index bei den Farbschaltern", "Error",
                    MessageBoxButton.OK, MessageBoxImage.Error);
            }


        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)     {
            e.Cancel = false;
            // Basis.writeWindowPosition2Registry(this, IGMRegistry.C_REG_ADR_IGM + "\\position", "dialog" + dbtable);
        }

        private void t_GotFocus(object sender, RoutedEventArgs e)    {
            ((TextBox)sender).SelectAll();
        }
    }
}
