﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CreateBitmap {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        public string C_REG_ADR_IGM = "SOFTWARE\\WILHELM\\CreateBitmap";

        private String dbtable = "CreateBitmap";

        // private Bitmap _bild = null;
        private CMiddleware middleware;
        private bool start = true;

        private uint callrandom = 0;

        private List<Object> quadliste1 = new List<Object>();
        
        public MainWindow()   {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            middleware = new CMiddleware();
            tHeight.Text = "10";
            tWidth.Text = "10";
            middleware.Pixelwidth = 10;
            middleware.Pixelheight = 10;

            start = false;
            createColorDepth();
            setPictures_Bits();
            setBitmapInfoHeader();
            Basis.setWindowPositionFromRegistry(this, C_REG_ADR_IGM + "\\position", "table" + dbtable);
            this.FontSize = 24;
            listboxPixel.FontSize = 20;
            tBitmapBits.FontSize = 20;
        }

        private void cbFontsize_SelectionChanged(object sender, SelectionChangedEventArgs e)     {
            if (start) return;
            int index = cbFontsize.SelectedIndex;
            if (index>0) {
                int fontsize = 10+(index << 1);
                this.FontSize = fontsize;
                listboxPixel.FontSize = fontsize+2;
                tBitmapBits.FontSize = fontsize+2;
            }

        }


        private void tWidth_TextChanged(object sender, TextChangedEventArgs e)     {
            if (start) return;
            uint width;
            if (uint.TryParse(tWidth.Text, out width)) {
                this.middleware.Pixelwidth = width;
                this.setPictures_Bits();
                this.setBitmapInfoHeader();
            }
        }

        private void tHeight_TextChanged(object sender, TextChangedEventArgs e)     {
            if (start) return;
            uint height;
            if (uint.TryParse(tWidth.Text, out height)) {
                this.middleware.Pixelheight = height;
                this.setPictures_Bits();
                this.setBitmapInfoHeader();
            }
        }

        private void bnNewColors_Click(object sender, RoutedEventArgs e)   {
            if (start) return;
            createColors();
        }

        private void cbColorDepth_SelectionChanged(object sender, SelectionChangedEventArgs e)    {
            if (start) return;
            createColorDepth();
            this.setBitmapInfoHeader();
        }
        private void setBitmapInfoHeader()    {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("DIB header size: " + middleware.bitmap.InfoBlock_size);
            sb.AppendLine("Image Width: " + middleware.bitmap.Pixelwidth);
            sb.AppendLine("Image Height (> 0 or < 0): " + middleware.bitmap.Pixelheight);
            sb.AppendLine("biPlanes (=1): " + middleware.bitmap.BiPlanes);
            sb.AppendLine("Farbebenen, nicht verwendet: 0");
            sb.AppendLine("Farbtiefe(1, 4, 8, 16, 24, 32) : " + middleware.bitmap.Colordepth);
            sb.AppendLine("KomprimierBit: " + middleware.bitmap.BiCompress);
            sb.AppendLine("Größe der Bilddaten(Pixel): " + middleware.bitmap.BiSizeIm);
            sb.AppendLine("Hor.Auflösung / pro Meter: "+ middleware.bitmap.BiXPixels_m);
            sb.AppendLine("Vert.Auflösung / pro Meter: "+ middleware.bitmap.BiYPixels_m);
            sb.AppendLine("biClrUsed: " + middleware.bitmap.BiColorUsed);
            sb.AppendLine("biClrImportant: "+ middleware.bitmap.BiColorImp);

            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.InfoBlock_size);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.Pixelwidth);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.Pixelheight);
            sb.AppendLine();
            sb.AppendFormat("{0:X2}", middleware.bitmap.BiPlanes);
            sb.AppendLine();
            sb.AppendFormat("{0:X2}", middleware.bitmap.Colordepth);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.BiCompress);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.BiSizeIm);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.BiXPixels_m);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.BiYPixels_m);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.BiColorUsed);
            sb.AppendLine();
            sb.AppendFormat("{0:X4}", middleware.bitmap.BiColorImp);
            sb.AppendLine();

            tBitmapInfoHeader.Text = sb.ToString();
        }

        // Farbton
        private void cbShadeofColor_SelectionChanged(object sender, SelectionChangedEventArgs e)  {
            if (start) return;
            createColors();
            
        }



        private void createColorDepth()    {
            switch (this.cbColorDepth.SelectedIndex) {
                case 0:
                    this.middleware.Colordepth = 1;
                    this.setColorPalette(2);
                    this.setPictures_Bits();
                    break;
                case 1:
                    this.middleware.Colordepth = 4;
                    this.setColorPalette(0x10);
                    this.setPictures_Bits();
                    break;
                case 2:
                    this.middleware.Colordepth = 8;
                    this.setColorPalette(0x100);
                    this.setPictures_Bits();
                    break;
                default: Basis.ErrorMsg("Fehler", "Fehler in der Case-Anweisung\nMethode: cbColordepth_SelectedIndexChanged\nIndex: " + this.cbColorDepth.SelectedIndex);
                    break;
            }
        }




        private void createColors()  {
            if (this.cbShadeofColor.SelectedIndex == 0) {
                createColorDepth();
            }
            else { 
                int numColors = 0;
                switch (this.cbColorDepth.SelectedIndex) {
                    case 0:
                        numColors = 2;
                        break;
                    case 1:
                        numColors = 0x10;
                        break;
                    case 2:
                        numColors = 0x100;
                        break;
                    default:
                        Basis.ErrorMsg("Fehler", "Fehler in der Case-Anweisung\nMethode: BnNewColors_Click\nIndex: " +
                        this.cbColorDepth.SelectedIndex);
                        break;
                }  // switch
                middleware.clearColor();
                int numred = 0;
                int numgreen = 0;
                int numblue = 0;
                int selectedIndex = this.cbShadeofColor.SelectedIndex;
                if (selectedIndex >= 0) {
                    switch (selectedIndex) {
                        // case 0 : Zufallszahlen
                        case 1:  // rot
                            numred = 0xff;
                            numgreen = 0x7f;
                            numblue = 0x7f;
                            break;
                        case 2:  // gelb
                            numred = 0xff;
                            numgreen = 0xff;
                            numblue = 0x7f;
                            break;
                        case 3: // blau
                            numred = 0x7f;
                            numgreen = 0x7f;
                            numblue = 0xff;
                            break;
                        case 4:  // grau
                            numred = 0xff;
                            numgreen = 0xff;
                            numblue = 0xff;
                            break;
                        case 5:  // grün
                            numred = 0x7f;
                            numgreen = 0xff;
                            numblue = 0x7f;
                            break;
                    }
                    CRGB_Quad item = new CRGB_Quad(0, 0, 0, 0);
                    middleware.addColor(item);
                    
                    Random random = new Random(); // 0x3ea36
                    uint nr = 0;
                    byte red=0, green = 0, blue = 0, dummy = 0;
                    for (int i = 1; i < (numColors - 1); i++) {
                        switch (selectedIndex) {
                            // case 0 : Zufallszahlen
                            case 1:  // rot
                                red = (byte)random.Next(0, numred);
                                green = (byte)random.Next(0, numgreen);
                                blue = (byte)random.Next(0, numblue);
                                if (green > red) green = red;
                                if (blue > red) blue = red;
                                break;
                            case 2:  // gelb
                                red = (byte)random.Next(0, 155);
                                red += 100;  // mindestens Farbwert
                                green = red;
                                green += (byte)random.Next(0, 10);

                                dummy = ((byte)random.Next(0, 10));
                                blue = (byte)((red+green)>>2);  // div 4, Hälfte des Mittelwertes
                                if (dummy < 5) {
                                    if (blue > 5) blue -= (byte)(dummy >> 1);
                                }
                                else {
                                    blue += (byte)(dummy >> 1);
                                }
                                break;
                            case 3: // blau
                                blue = (byte)random.Next(0, numblue);
                                red = (byte)random.Next(0, numred);
                                green = (byte)random.Next(0, numgreen);
                                if (red > blue) red = blue;
                                if (green > blue) green = blue;
                                break;

                            case 4:  // grau
                                red = (byte)random.Next(0, numred);
                                dummy = ((byte)random.Next(0, 10));
                                green = red;
                                if (dummy<5) {
                                    if (green > 5) green -= (byte)(dummy>>1);
                                }
                                else {
                                    green += (byte)(dummy >> 1);
                                }

                                dummy = ((byte)random.Next(0, 10));
                                blue = red;
                                if (dummy < 5) {
                                    if (blue > 5) blue -= (byte)(dummy >> 1);
                                }
                                else {
                                    blue += (byte)(dummy >> 1);
                                }
                                break;

                            case 5:  // grün
                                green = (byte)random.Next(0, numgreen);
                                blue = (byte)random.Next(0, numblue);
                                red = (byte)random.Next(0, numred);
                                if (red > green) red = green;
                                if (blue > green) blue = green;
                                break;
                        }
                        item = new CRGB_Quad(++nr, red, green, blue);
                        middleware.addColor(item);
                        middleware.addColor(item);
                    }
                    item = new CRGB_Quad(++nr, (byte)numred, (byte)numgreen, (byte)numblue);
                    middleware.addColor(item);
                    setlistboxColorPalette1();
                }
            }
        }  // createColors

        private void setlistboxColorPalette1()    {
            listboxColorPalette1.Items.Clear();
            listboxColorPalette1.Items.Add("Nr" + callrandom + "\tRed\tGreen\tBlue");
            foreach(CRGB_Quad quad in middleware.getQuadliste()) {
                listboxColorPalette1.Items.Add(quad);
            }
        }

        private void setColorPalette(uint colors)   {
            CRGB_Quad quad;
            byte red, green, blue; 
            callrandom++;
            this.middleware.clearColor();
            Random random = new Random(); // 0x3ea36
            switch (colors) {
                case 2:
                    quad = new CRGB_Quad(0, 255, 255, 255);
                    middleware.addColor(quad);
                    green = (byte)random.Next(0, 255);
                    blue = (byte)random.Next(0, 255);
                    red = (byte)random.Next(0, 255);
                    if(callrandom == 1)
                        quad = new CRGB_Quad(1, 0, 0, 0);
                    else
                        quad = new CRGB_Quad(1, red, green, blue);
                    middleware.addColor(quad);
                    setlistboxColorPalette1();
                    break;

                case 0x10:
                case 0x100:
                    uint nr = 0;
                    uint num = 0xffffff / colors;
                    uint num2 = num;
                    quad = new CRGB_Quad(nr, 0, 0, 0);
                    middleware.addColor(quad);

                    for (int i = 1; i < (colors-1); i++) {
                        red = (byte)random.Next(0, 0xff);
                        green = (byte)random.Next(0, 0xff);
                        blue = (byte)random.Next(0, 0xff);
                        quad = new CRGB_Quad(++nr, red, green, blue);
                        middleware.addColor(quad);
                    }
                    quad = new CRGB_Quad(++nr, 0xff, 0xff, 0xff);
                    middleware.addColor(quad);
                    setlistboxColorPalette1();
                    break;
                default: Basis.ErrorMsg("Fehler", "Fehler in der Case-Anweisung\nMethode: setColorPalette\nIndex: " + colors);
                    break;
            } // switch
        }

        private void listboxColorPalette1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int index = listboxColorPalette1.SelectedIndex;
            if (index > 0) {
                CRGB_Quad quad = middleware.getQuad(index-1);
                panel.Background = new SolidColorBrush( Color.FromRgb(quad.red, quad.green, quad.blue) );
            }
        }

        private void listboxColorPalette_MouseDoubleClick(object sender, MouseButtonEventArgs e)   {
            int index = listboxColorPalette1.SelectedIndex;
            if (index > 0) {
                CRGB_Quad quad = middleware.getQuad(index - 1);
                FColorDialog dialog = new FColorDialog(this);
                dialog.setColor(quad.red, quad.green, quad.blue);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    quad.red=dialog.Red;
                    quad.green = dialog.Green;
                    quad.blue = dialog.Blue;
                    setlistboxColorPalette1();
                }
            }
        }

        private void bnNewBits_Click(object sender, RoutedEventArgs e)  {
            setPictures_Bits();
        }


        private void cbNumberofBytesPerRow_SelectionChanged(object sender, SelectionChangedEventArgs e)   {
            if (start) return;
            showBitmapBits();
        }

        private void setPictures_Bits()  {
            // Jede Zeile hat IMMER ein Vielfaches von 4 bytes,    5 Bytes ==> 8 Bytes

            uint numberofpixel = middleware.Pixelwidth * this.middleware.Colordepth;  // 40
            uint anzahlBytesProZeile = (numberofpixel) >> 3;   // 5 Bytes
            if (numberofpixel % 8 > 0) {
                anzahlBytesProZeile++;  // Rundung, der letzte Rest
            }
            // check ob Vielfaches
            uint restBytes = 0;
            uint rest = anzahlBytesProZeile % 4;
            if (rest>0) {
                restBytes=4- rest;
            }

            uint gesamtanzahlBytes = this.middleware.Pixelheight * (anzahlBytesProZeile+ restBytes);
            middleware.bitmap.BiSizeIm = gesamtanzahlBytes;


            uint n = middleware.Pixelheight * middleware.Pixelwidth;
            labelPixel.Content = "Anzahl Pixel: " + n ;
            labelBitfolge.Content = "Bitfolge des Bildes: " + gesamtanzahlBytes + " Bytes";
            DateTime now = DateTime.Now;
            long num4 = now.Second * now.Millisecond;

            listboxPixel.Items.Clear();
            this.middleware.clearBits();
            Random random = new Random();
            
            uint anzStellen = (uint)(Math.Log10(n) + 1);
            String stellen = "";
            for (int i=0;i<anzStellen;i++) {
                stellen += "0";
            }
            int numberofColors = (int)middleware.NumberofColors;
            for (int i = 0; i < n; i++) {
                byte pixel = (byte)random.Next(0, numberofColors);
                this.middleware.addPixel(pixel);
                listboxPixel.Items.Add(i.ToString(stellen) +" "+pixel);
            }
            middleware.createBitmapByteliste();

            showBitmapBits();
        }

        private void showBitmapBits()   {
            StringBuilder sb = new StringBuilder();
            int numberofbytesperRow = cbNumberofBytesPerRow.SelectedIndex + 4;
            for (int i = 0; i < middleware.listeBits.Count; i++) {
                Object obj = middleware.listeBits[i];
                Type t = obj.GetType();

                byte item = (byte)middleware.listeBits[i];
                if (i % numberofbytesperRow == 0 && i > 0) {
                    sb.AppendLine();
                }
                sb.AppendFormat("{0:X2}", item);
                sb.Append("\t");
                //this.middleware.addBits(item);
            }
            tBitmapBits.Text = sb.ToString();
        }

        private void listboxPixel_MouseDoubleClick(object sender, MouseButtonEventArgs e)   {

        }



        private void bnSave_Click(object sender, RoutedEventArgs e)    {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Title = "Save as";
            saveFileDialog1.Filter = "Bitmap files (*.bmp)|*.bmp|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".bmp";
            saveFileDialog1.InitialDirectory = Basis.getProgPath();
            saveFileDialog1.FileName = "bild.bmp";

            if (saveFileDialog1.ShowDialog() == true) {
                middleware.Filename = saveFileDialog1.FileName;
                middleware.save2File();
                Process Prog = new Process();
                Prog.StartInfo.FileName = middleware.Filename;
                Prog.StartInfo.Arguments = "";
                Prog.Start();
                Prog.Close();
            }
        }  // middleware.Filename


        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)   {
            Basis.writeWindowPosition2Registry(this, C_REG_ADR_IGM + "\\position", "table" + dbtable);
        }

    }
}
